<?php
/*
  Shipping Insurance Module
  ot_insurance.php, v 1.0 2003/12/03
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2002 osCommerce

  Modified to work with zen cart


  Released under the GNU General Public License
*/

  class ot_insurance {
    var $title, $output;

    function ot_insurance() {
      $this->code = 'ot_insurance';
      $this->title = MODULE_ORDER_TOTAL_INSURANCE_TITLE;
      $this->description = MODULE_ORDER_TOTAL_INSURANCE_DESCRIPTION;
      $this->enabled = MODULE_ORDER_TOTAL_INSURANCE_STATUS;
      $this->sort_order = MODULE_ORDER_TOTAL_INSURANCE_SORT_ORDER;

      $this->output = array();
    }

    function process() {
      global $order, $currencies;

      if (MODULE_ORDER_TOTAL_INSURANCE_USE == 'true') {
        switch (MODULE_ORDER_TOTAL_INSURANCE_DESTINATION) {
          case 'national':
            if ($order->delivery['country_id'] == STORE_COUNTRY) $pass = true; break;
          case 'international':
            if ($order->delivery['country_id'] != STORE_COUNTRY) $pass = true; break;
          case 'both':
            $pass = true; break;
          default:
            $pass = false; break;
        }

        if ($pass == true) {
          $tax = zen_get_tax_rate(MODULE_ORDER_TOTAL_INSURANCE_TAX_CLASS);
$how_often = ceil(($order->info['total']- $order->info['tax'] - MODULE_ORDER_TOTAL_INSURANCE_OVER)/MODULE_ORDER_TOTAL_INSURANCE_INCREMENT);

          $order->info['tax'] += zen_calculate_tax((MODULE_ORDER_TOTAL_INSURANCE_FEE * $how_often), $tax);
          $order->info['tax_groups']["{$tax}"] += zen_calculate_tax((MODULE_ORDER_TOTAL_INSURANCE_FEE * $how_often), $tax);
          $order->info['total'] += (MODULE_ORDER_TOTAL_INSURANCE_FEE * $how_often) + zen_calculate_tax(MODULE_ORDER_TOTAL_INSURANCE_FEE, $tax);
          $this->output[] = array('title' => $this->title . ':',
                                  'text' => $currencies->format(zen_add_tax((MODULE_ORDER_TOTAL_INSURANCE_FEE * $how_often), $tax), true, $order->info['currency'], $order->info['currency_value']),
                                  'value' => zen_add_tax((MODULE_ORDER_TOTAL_INSURANCE_FEE * $how_often), $tax));
        }
      }
    }

    function check() {
    global $db;
      if (!isset($this->check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_INSURANCE_STATUS'");
        $this->check = $check_query->RecordCount();
      }

      return $this->check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_INSURANCE_STATUS', 'MODULE_ORDER_TOTAL_INSURANCE_SORT_ORDER', 'MODULE_ORDER_TOTAL_INSURANCE_USE', 'MODULE_ORDER_TOTAL_INSURANCE_OVER', 'MODULE_ORDER_TOTAL_INSURANCE_INCREMENT', 'MODULE_ORDER_TOTAL_INSURANCE_FEE', 'MODULE_ORDER_TOTAL_INSURANCE_DESTINATION', 'MODULE_ORDER_TOTAL_INSURANCE_TAX_CLASS');
    }

    function install() {
    global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('显示运输保费', 'MODULE_ORDER_TOTAL_INSURANCE_STATUS', 'true', '要显示运输保费吗?', '6', '1','zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('排序顺序', 'MODULE_ORDER_TOTAL_INSURANCE_SORT_ORDER', '4', '显示的顺序。显示在后的模块，不计算保费。排序值不能重复。', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('使用运输保费?', 'MODULE_ORDER_TOTAL_INSURANCE_USE', 'false', '要使用运输保费吗?', '6', '3', 'zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('起保金额', 'MODULE_ORDER_TOTAL_INSURANCE_OVER', '100', '高于该值的订单金额，才计算保险费(例如, UPS运费包含价值低于$100的保险, 所以可以设置为100。如果设置为0，就是保险所有金额。)', '6', '4', 'currencies->format', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('保险金额', 'MODULE_ORDER_TOTAL_INSURANCE_INCREMENT', '100', '用于计算保费时，保险费率对应的<b>商品金额</b>。(例如，每价值100元的商品，保费0.50元，那么这里输入100)', '6', '4', 'currencies->format', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('保险费率', 'MODULE_ORDER_TOTAL_INSURANCE_FEE', '.50', '上面设置的保险金额对应的保费。(例如，每价值100元的商品，保费0.50元，那么这里输入0.50).', '6', '5', 'currencies->format', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('保费适用的订单', 'MODULE_ORDER_TOTAL_INSURANCE_DESTINATION', 'both', '保费适用于发送到设定地区的订单。', '6', '6', 'zen_cfg_select_option(array(\'national\', \'international\', \'both\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('税率种类', 'MODULE_ORDER_TOTAL_INSURANCE_TAX_CLASS', '0', '计算运费使用的税率种类。', '6', '7', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
    }

    function remove() {
    global $db;
      $keys = '';
      $keys_array = $this->keys();
      for ($i=0; $i<sizeof($keys_array); $i++) {
        $keys .= "'" . $keys_array[$i] . "',";
      }
      $keys = substr($keys, 0, -1);

      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
    }
  }
?>